#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<ctype.h>

static FILE *file=NULL, *dfile=NULL;
static union{
	float f;
	double d;
	int i;
	float *pf;
	double *pd;
} _fp_num;

typedef struct _FitsField{
	char	*keyword;
	char	*value;
	/*int		type;*/
} FitsField;

void set_file(FILE *f){
	file=f;
}

#define write_Field(fld)	write_data(

int write_keyword(const char *k){
	int size=0,i=0;
	size=(int)strlen(k);
	for(i=0;i<size;i++) fprintf(file,"%c",toupper(k[i]));
	for(i=size;i<8;i++) fprintf(file," ");
	return 8;	
}

void write_to_file(const char *keyword,const char *value){
	static int size=0, i=0;
	static char is_end=0;
	static int tsum=0;
	
	is_end=(strcmp(keyword,"end")==0);

	size=write_keyword(keyword);
	if(value && !is_end){
		if(value[0]=='\0') ++value;
		else size+=fprintf(file,"= ");
		
		if(value[0]=='T' || value[0]=='F'){
			for(i=0;i<19;i++) size+=fprintf(file," ");
		}
		else if(value[0]==0x27){}		
		else if(isdigit(value[0]) || value[0]=='.' || value[0]=='-' || value[0]=='+'){
			for(i=0;i<20-(int)strlen(value);i++) size+=fprintf(file," ");
		}
		size+=fprintf(file,"%s",value);
	}
	for(i=size;i<80;i++) fprintf(file," ");
	tsum+=80;
	tsum%=2880;
	if(is_end && tsum){
		tsum=(2880-tsum);
		for(i=0;i<tsum;i++) fprintf(file," ");
		tsum=0;
	}
}

#define TYPE_TEXT		TYPE_STRING
#define TYPE_STRING		0
#define TYPE_BOOL		1
#define TYPE_INT		2
#define TYPE_UINT		3
#define TYPE_FLOAT		4
#define TYPE_DOUBLE		5
#define TYPE_NOEQ		-1

void write_data(const char* keyword,const void *data,int type){
	static char buff[83];
	double *d=NULL;
	float *f=NULL;
	int *i=NULL;

	memset(buff,0,sizeof(buff));
	switch(type){
		case TYPE_STRING: // string
		default:
			strcat(buff,"'");
			strcat(buff,(char*)data);
			strcat(buff,"'");
			break;
		case TYPE_BOOL:
			buff[0]=(data ? 'T' : 'F');
			buff[1]=0;	
			break;
		case TYPE_INT:
		case TYPE_UINT:
			i=(int*)data;
			sprintf(buff,(type==TYPE_INT ? "%d" : "%u"),(*i));
			break;
		case TYPE_FLOAT: // float
		case TYPE_DOUBLE: // double
			f=(float*)data;
			d=(double*)data;
			sprintf(buff,"%f",(type==TYPE_FLOAT ? (*f) : (*d)));
			break;
		case TYPE_NOEQ:		
			sprintf(buff,"%c%s",'\0',(char*)data);
			break;
	}
	write_to_file(keyword,buff);
}


#define write_bool_s(kw,v)		write_data((kw),(void*)(v),TYPE_BOOL)
#define write_string_s(kw,v)	write_data((kw),(v),TYPE_STRING)
#define write_text_s(kw,v)		write_data((kw),#v,TYPE_TEXT)
#define write_int_s(kw,v)		_fp_num.i=(int)(v); write_data((kw),(void*)(&_fp_num.i),TYPE_INT)
#define write_uint_s(kw,v)		_fp_num.i=(int)(v); write_data((kw),(void*)(&_fp_num.i),TYPE_UINT)
#define write_float_s(keyword,ff) _fp_num.f=(ff); \
								write_data((keyword),(void*)(& _fp_num.f),TYPE_FLOAT)
#define write_double_s(keyword,dd) _fp_num.d=(dd); \
								 write_data((keyword),(void*)(& _fp_num.d),TYPE_DOUBLE)
#define write_null_s(keyword)		write_to_file((keyword),NULL)

#define write_HISTORY_t(v)			write_HISTORY_s(#v)
#define write_COMMENT_t(v)			write_COMMENT_s(#v)
#define write_HISTORY_s(v)			write_data("history",(v),TYPE_NOEQ)
#define write_COMMENT_s(v)			write_data("comment",(v),TYPE_NOEQ)

#define write_bool(keyword,val)	write_data(#keyword,(void*)(val),1)
#define write_string(keyword,val) write_data(#keyword,(val),0)
#define write_text(keyword,val)	 write_data(#keyword,#val,0)
#define write_int(keyword,val)	write_int_s(#keyword,(val))
#define write_uint(keyword,val) write_uint_s(#keyword,(val))
#define write_float(keyword,ff) write_float_s(#keyword,ff)
#define write_double(keyword,dd) write_double_s(#keyword,dd)
#define write_null(keyword)	write_to_file(#keyword,NULL)


